#ifndef PARSER_H
#define PARSER_H

#include "lexer.h"
#include "sentencia.h"
#include <vector>
using namespace std;


struct funcion {
   token_anotada* nombre;
   vector<token_anotada*> parametros;
   vector<sentencia*> instrucciones;  
};

struct arbol_sintactico {
   vector<token_anotada*> inclusiones;
   vector<funcion> funciones;
};

funcion parser_funcion(token_anotada*& entrada)
{
   funcion f;
   
   espera(entrada, FUNCTION);
   espera(entrada, IDENTIFICADOR);
   espera(entrada, PARENTESIS_IZQ);
   
   f.nombre = entrada - 2;
   
   while (entrada->valor != PARENTESIS_DER) {
      espera(entrada, IDENTIFICADOR);
      f.parametros.push_back(entrada - 1);
      
      if (entrada->valor != PARENTESIS_DER) {
         espera(entrada, COMA);
      }
   }
   
   espera(++entrada, LLAVE_IZQ);
   
   while (entrada->valor != LLAVE_DER) {
      f.instrucciones.push_back(parser_sentencia(entrada));   
   }
   
   ++entrada;
   return f;
}

arbol_sintactico parser(token_anotada* entrada)
{
   arbol_sintactico arbol;
   
   while (entrada->valor == INCLUDE) {
      ++entrada;
      
      espera(entrada, LITERAL_CADENA);
      arbol.inclusiones.push_back(entrada - 1);
      espera(entrada, PUNTO_COMA);
   }

   while (entrada->valor != FIN_ARCHIVO) {
      arbol.funciones.push_back(parser_funcion(entrada));
   }
   
   return arbol;
}

#endif
